import * as React from 'react';
import ListItem from '@mui/material/ListItem';
import List from '@mui/material/List';

import ListItemIcon from '@mui/material/ListItemIcon';
import ListItemText from '@mui/material/ListItemText';
import ListSubheader from '@mui/material/ListSubheader';

import { Nav } from 'react-bootstrap';

import HomeIcon from '@mui/icons-material/Home'
import WorkIcon from '@mui/icons-material/Work';
import VisibilityOffIcon from '@mui/icons-material/VisibilityOff';
import PeopleAltIcon from '@mui/icons-material/PeopleAlt';
import HistoryIcon from '@mui/icons-material/History';
import EqualizerIcon from '@mui/icons-material/Equalizer';
import FingerprintIcon from '@mui/icons-material/Fingerprint';

import MiscellaneousServicesIcon from '@mui/icons-material/MiscellaneousServices';

import OndemandVideoIcon from '@mui/icons-material/OndemandVideo';
import StarIcon from '@mui/icons-material/Star';
import SupportAgentIcon from '@mui/icons-material/SupportAgent';

import Collapse from '@mui/material/Collapse';
import ExpandLess from '@mui/icons-material/ExpandLess';
import ExpandMore from '@mui/icons-material/ExpandMore';
import { useNavigate, useResolvedPath, useMatch } from 'react-router-dom'

function NavItem (props) {
    
    let navigate = useNavigate()
    let resolved = useResolvedPath(props.route);
    let match = useMatch({ path: resolved.pathname, end: true });

    return(
        <ListItem
            sx={{ color : '#25344f'}}
            selected={match}
            onClick={() => navigate(props.route) } 
            button
        >
            <ListItemIcon>
                {props.icon && props.icon}
            </ListItemIcon>
            <ListItemText 
                sx={{
                    fontSize: 12,
                    ' .css-10hburv-MuiTypography-root' : {
                        fontSize : '.875rem'
                    },
                }}
                primary={props.title} 
            />
        </ListItem>
    )
}


export const MainListItems = (props) =>  {

    const [open, setOpen] = React.useState(false);

    const showPruebas = () => {
        if(!props.AppBarVisible){
            props.setAppBarVisible(true);
        }
        setOpen(!open);
    };

    return(
        <List>

            <ListSubheader inset>MENÚ</ListSubheader>

            <NavItem icon={<HomeIcon/>} title="Inicio" route="home" />
            <NavItem icon={<WorkIcon/>} title="Puestos" route="puestos" />
            <NavItem icon={<VisibilityOffIcon/>}   index={2} title="Contraseñas" route="contrasenas" />
            <NavItem icon={<PeopleAltIcon/>}  title="Expedientes" route="expedientes" />
            <NavItem icon={<EqualizerIcon/>} title="Resultados" route="resultados" />

            {/*<ListItem selected={false} onClick={showPruebas}>*/}
            <ListItem onClick={showPruebas}>
                <ListItemIcon>
                    <FingerprintIcon />
                </ListItemIcon>


                <ListItemText 
                    sx={{
                        fontSize: 12,
                        ' .css-10hburv-MuiTypography-root' : {
                            fontSize : '.875rem'
                        },
                    }}
                    primary="Pruebas" 
                />
                {open ? <ExpandLess /> : <ExpandMore />}
            </ListItem>


            <Collapse in={open} timeout="auto" unmountOnExit>
                <List component="div" disablePadding>

                    <NavItem route="pruebas/crear" title="Crear Prueba" />
                    <NavItem route="pruebas/listar"  title="Listado de pruebas" />
                    <NavItem route="pruebas/aplicar"  title="Aplicar" />
                    <NavItem route="pruebas/respuestas" title="Respuestas" />
                    <NavItem route="pruebas/calificaciones" title="Calificaciones" />

                </List>
            </Collapse>

            <NavItem icon={<MiscellaneousServicesIcon/>} title="Configuraciones" route="configuraciones" />
            <NavItem icon={<HistoryIcon/>} title="Historial" route="historial" />
        </List>
    )
};

export const secondaryListItems = (
    <Nav>
        <ListSubheader inset>EXTRAS</ListSubheader>
        <NavItem selected={false} icon={<StarIcon/>} title="Elementos" route="/work" />
        <NavItem selected={false} icon={<OndemandVideoIcon/>} title="Tutoriales" route="/work" />
        <NavItem selected={false} icon={<SupportAgentIcon/>} title="Asistencia Técnica" route="/work" />
    </Nav>
);
